( -----------------   JEU DE CASES ------------------ )

( *****     DEBUT FICTIF DU PROGRAMME ***** )
( Cette dfinition, la premire donc la plus basse dans la pile, sert  dlimiter )
( le dbut de l'implantation du programme dans le vocabulaire. )
( Cette astuce est trs utile quand il faut nettoyer la mmoire des mots devenus inutiles )
( Ainsi, dans ce cas, il suffira de taper forget debut_jeucases pour effacer le )
( programme de la mmoire.)
( En gnralisant cette pratique, on gagne en commodit de manipulation.)

: debut_jeucases ;


( *****     DEFINITION DES VARIABLES ET CONSTANTES     ***** )

10 string tcases$
variable score
variable indfin
variable ligc
variable colc
variable numc
variable colx
variable ligy

32 constant COULTITRE
35 constant COULSCORE1
37 constant COULSCORE2
35 constant COULALLUME
33 constant COULETEINT
37 constant COULCHIFFRE
31 constant COULSAISIE
30 constant COULFOND

( La variable tcases$ contient "0" pour allum, "1" pour teint )
( On accde  la valeur d'une case en prenant l'adresse de tcases$ )
( et en y ajoutant le n de case -1. A l'adresse rsultante, on trouve )
( le caractre voulu ,lu par C@ )


( *****     TEST SI GAGNE     ***** )
: gagne?

( comparer caractere par caractere les couleurs des cases )
( avec la combinaison gagnante. A la 1ere diffrence, sortir)
1 indfin !
9 0 do
    ( i pose sur la pile le n de case de 0  8, )
    ( tcases$ pose l'adresse de tcases et la longueur ...)
    ( que l'on supprime par drop )
    ( on ajoute ensuite i  l'adresse de tcases pour trouver le i me caractre ...)
    ( que l'on lit par c@ : 1 octet seulement et pas un mot de 16 bits )
    
    i tcases$      drop + c@ ( drop ignore la lg de la chaine)
    i " 000010000" drop + c@
    =
    if
    else
        0 indfin !
        leave
    then
loop
	
;


( *****     INVERSION D'UNE CASE     ***** )
: inver
( sur la pile, on a le n de case  inverser )
(   case - 1 pour partir  0 pour la premiere )
1 - dup ( conserver ce n de case pour la maj ) 

( rcuprer la valeur de la case en format caractere )
tcases$ drop + c@
( calculer 1 - case ; caractere 0 = '48' en ascii;  1 = '49' en ascii )
48 - (donne 0 ou 1)
1 swap - (calculer 1 - resultat ci-dessus) 
48 + (retransformer en caractere ascii en ajoutant 48)
( echanger le n de case et la nouvelle valeur ...)
swap 
( ... pour d'abord calculer l'adresse puis transferer la valeur )
tcases$ drop + 
c!

;


( *****     LECTURE D'UNE TOUCHE     ***** )
: lectouche

( Afficher l'invite de saisie en ligne 20 )
COULSAISIE COULFOND colors
24 20 at
." Quelle case ? (0=fin) "

( Attendre une touche dont la valeur viendra sur la pile)
key

( Vrifier qu'il s'agit de 0  9, soit 48  57 en ascii )
dup 48 < if exit then
dup 57 > if exit then
( Si ok, afficher la touche )
dup emit

1 score +! (incremente le score sur la pile, puis le stocke par !)

case
    48 of    
	1 indfin !
	endof
    49 of    
	1 inver 2 inver 4 inver
	endof
    50 of    
	1 inver 2 inver 3 inver
	endof
    51 of    
	2 inver 3 inver 6 inver
	endof
    52 of    
	1 inver 4 inver 7 inver
	endof
    53 of    
	2 inver 4 inver 6 inver 8 inver 5 inver
	endof
    54 of    
	3 inver 6 inver 9 inver
	endof
    55 of    
	4 inver 7 inver 8 inver
	endof
    56 of    
	7 inver 8 inver 9 inver
	endof
    57 of    
	8 inver 9 inver 6 inver
	endof

endcase
;


( *****     AFFICHAGE D'UNE CASE     ***** )
: aff1case

( extraire la couleur de la case numc -1 )
tcases$ numc @ 1 - 1 mid$
(    ignorer longueur et prendre caractere )
drop count
( si 1, vert, sinon rouge )
49 = 
if
  COULALLUME
else
  COULETEINT
then
(    sauvegarder pour la fin)
dup 
(    echanger l'ordre des couleurs et afficher )
COULFOND swap colors

( calculer la position de la case )
colc @ 12 * 12 + colx !
ligc @ 5  * 0  + ligy !
(    afficher les 3 lignes )
4 1 do
  colx @ ligy @ at
  ."          "
  1 ligy +!
loop

( afficher le n au centre)
4 colx @ +     ligy @ 2 -     at
(    recuperer la couleur de fond et afficher en blanc)
COULCHIFFRE swap colors
numc @ 48 + emit

;


( *****     AFFICHER LES 9 CASES     ***** )
: aff9cases

( Afficher le score )
5 7 at COULSCORE1 COULFOND colors ." SCORE"
5 9 at COULSCORE2 COULFOND colors score @ 3 .r

( Boucler pour les 9 cases : 3 lignes de 3 cases )
0 numc !
4 1 do
  i ligc !
  4 1 do
    i colc !
    1 numc +!
    aff1case
  loop
loop

;


( *****     BOUCLE PRINCIPALE DU JEU     ***** )
: jeucases

( Titre )
dark
34 0 at COULTITRE COULFOND colors ." Jeu des Cases"

( tirage au sort des cases, en principe )
" 011100101" tcases$ $!

0 score !
0 indfin !

( Continuer tant que l'indicateur indfin est  0 cd : )
(	. pas d'appui sur touche "0" )
(	. pas combinaison gagnante )

Begin
    aff9cases			
    lectouche
    indfin @ 0 = ( test si on a choisi "0" )
      if gagne? then
    indfin @ 0 >
until

( Afficher la derniere combinaison )
aff9cases
( Sortir en repositionnant le curseur )
42 COULFOND colors 1 22 at 

;

